#!/usr/bin/php
<?php
//constante
$DEFAULT_TIMEOUT = 10; //seconds
$STR_STATUS=array("OK","WARNING","CRITICAL","UNKNOWN");
$INT_STATUS=array_flip($STR_STATUS);
$PRIORITIES_STATES=array("CRITICAL","WARNING","UNKNOWN","OK");
$PING_PATH="/usr/local/esia/plugins/check_icmp";
//Récupération des paramètres//
$SHORT_OPTS="H:w:c:n:l:t:b:h";
$LONG_OPTS=array("host:","warning:","critical:","packet:","ttl:","timeout:","byte:","help");

$options = getopt($SHORT_OPTS, $LONG_OPTS);

if ( isset($options["help"]) || isset($options["h"]) ){
	print_help();
	exit($INT_STATUS["UNKNOWN"]);
}

$host 		= getParam($options,"host","H");
$warning 	= getParam($options,"warning","w","200,40,100");
$critical 	= getParam($options,"critical","c","500,80,200");
$packet 	= getParam($options,"packet","n",5);
$ttl 	    = getParam($options,"ttl","l",64);
$timeout 	= getParam($options,"timeout","t",$DEFAULT_TIMEOUT);
$byte 	    = getParam($options,"byte","b",64);
if(empty($host))
{
    exit_state("UNKNOWN","Host not specified!!!",TRUE);
}
$arr_warning = explode(",", $warning);
if(count($arr_warning) ==2)
{
    $arr_warning[2]=100;
}
elseif(count($arr_warning) !=3)
{
    exit_state("UNKNOWN","Bad warning paramèter",TRUE);
}
$arr_critical = explode(",", $critical);
if(count($arr_critical) ==2)
{
    $arr_critical[2]=150;
}
elseif(count($arr_critical) !=3)
{
    exit_state("UNKNOWN","Bad critical paramèter",TRUE);
}
//Armement timeout
pcntl_alarm($timeout+2);
pcntl_signal(SIGALRM, "sig_handler");

$command_line = "$PING_PATH -H $host -w $arr_warning[0],$arr_warning[1] -c $arr_critical[0],$arr_critical[1]";

exec($command_line,$outputs,$retvar);
//echo $retvar." = ".$command_line."\n";
$out="";
foreach($outputs as $line)
{
    $out.="$line";
}
//echo "$out";
//si le ping est déjà en critique on ne va pas plus loin
if($retvar!=2)
{
    echo "$out\n";
    exit($retvar);
}
else
{
    if(preg_match('#[Lost|lost]\s+100\%#', $out))
    {
        echo "PC is down \n";
        exit(0);
    }
    else
    {
        echo "$out\n";
        exit($retvar);
    }
}

//
//Fonction
//

function print_usage(){
	echo "USAGE :  check_icmp_pc -H <IP> -w 200,40,100 -c 500,80,200\n";
    print_help();
}

function print_help(){

	echo "\n";
	echo "\t-H, ".str_pad("--host=target",20)			."IP or FQDN\n";
	echo "\t-w, ".str_pad("--warning=WARNING",20)	."warning threshold (default: 200ms,40%,100ms)\n";
	echo "\t-c, ".str_pad("--critical=CRITICAL",20)	."critical threshold (default: 500ms,80%,200ms)\n";
    echo "\t-n, ".str_pad("--packet=NUMBER",20)	."number of packets to send (default: 5)\n";
    echo "\t-l, ".str_pad("--ttl=TTL",20)	." TTL on outgoing packets\n";
    echo "\t-t, ".str_pad("--timeout=TIMEOUT",20)	."timeout value (default:  10 seconds)\n";
    echo "\t-b, ".str_pad("--byte=TIMEOUT",20)	."Number of icmp data bytes to send. Packet size will be data bytes + icmp header (currently 68 + 8)\n";
	echo "\n";
	echo "\t-h, ".str_pad("--help",20)				."Print this help\n";
    echo "Notes:\n";
    echo "\t The threshold alert and critical format means this: 200,40%,100\n";
    echo "\t    200 is the latency\n";
    echo "\t    40 is the lost packet percentage\n";
    echo "\t    100 is the maximum delta between the different ping latencies\n";
	echo "\n";
}

function getParam($options,$name1,$name2,$default=null){
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

function isNull($value){
	return ( empty($value) || strtolower($value) == "null" || strtolower($value) == "none" || $value == null );
}

function exit_state($state,$msg=null,$usage=false){
	$STR_STATUS=$GLOBALS["STR_STATUS"];
	$INT_STATUS=$GLOBALS["INT_STATUS"];

	$ret=$state;
	if( is_string($state) ) $ret=$INT_STATUS[strtoupper($state)];
	else $state=$STR_STATUS[$ret];

	if( $msg != null ) echo "$state - $msg\n";
	if( $usage ) print_usage();
	exit($ret);
}

declare(ticks = 1);
function sig_handler($signo){
	global $timeout;		
	exit_state("UNKNOWN","Timeout after $timeout seconds");
}
?>



?>
