#!/usr/bin/perl -w
################## check_snmp_cyberoam_env #################
my $Version='1.0';
# Date : Sept 12 2017
# Author : Victor Marin
# Help : esia-sa.com
#################################################################

use POSIX qw(strftime);
use Switch;
use strict;
use Net::SNMP;
use Getopt::Long;
my $PROGNAME='check_snmp_cyberoam_env.pl';
my $TIMEOUT = 15;
my %ERRORS=('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'DEPENDENT'=>4);
my ($opt_h,$opt_V);
my $domain = "UDP/IPV4"; # domain UDP/IPV6;UDP/IPV4;TCP/IPV6;TCP/IPV4
my $community = "esia_read";
my $snmp_version = 2;
my ($hostname);
my $warning='70';
my $port='161';
my $critical='80';
my $output="";
my $status="";
my $state="";
my $service="";
my $result;
my ($snmp, $snmperror);
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);
my @tab_value_read;


my $cyberoam_descr            = "1.3.6.1.2.1.1.1.0";

# Nombre de User connecté
my $cyberoam_liveUsers		  = "1.3.6.1.4.1.21067.2.1.2.6.0";
my $cyberoam_systemDate 	  = "1.3.6.1.4.1.21067.2.1.2.1";

# Nombre de requete
my $cyberoam_httpHits		  = "1.3.6.1.4.1.21067.2.1.2.7.0";
my $cyberoam_ftpHits		  = "1.3.6.1.4.1.21067.2.1.2.8.0";
my $cyberoam_mailHits		  = "1.3.6.1.4.1.21067.2.1.2.9.0";
my $cyberoam_pop3Hits		  = "1.3.6.1.4.1.21067.2.1.2.9.1.0";
my $cyberoam_imapHits		  = "1.3.6.1.4.1.21067.2.1.2.9.2.0";
my $cyberoam_smtpHits		  = "1.3.6.1.4.1.21067.2.1.2.9.3.0";


my $cyberoam_cyberoamVersion  = "1.3.6.1.4.1.21067.2.1.1.3.0";

# Status 'SubStatus' : 1 trial,2 unsubscribed,3 subscribed,4 expired

#liAppliance	
my $cyberoam_appRegStatus	  = "1.3.6.1.4.1.21067.2.1.3.1.1.0";
my $cyberoam_appExpiryDate	  = "1.3.6.1.4.1.21067.2.1.3.1.2.0";

#liSupport
my $cyberoam_supportSubStatus = "1.3.6.1.4.1.21067.2.1.3.2.1.0";
my $cyberoam_supportExpiryDate= "1.3.6.1.4.1.21067.2.1.3.2.2.0";

# Anti-virus
my $cyberoam_avVersion		  = "1.3.6.1.4.1.21067.2.1.1.5.0";
my $cyberoam_avSubStatus	  = "1.3.6.1.4.1.21067.2.1.3.3.1.0";
my $cyberoam_avExpiryDate	  = "1.3.6.1.4.1.21067.2.1.3.3.2.0"; # Exemple => Hex-STRING: 07 E2 05 12 

# Anti-spam
my $cyberoam_asVersion		  = "1.3.6.1.4.1.21067.2.1.1.6.0";
my $cyberoam_asSubStatus	  = "1.3.6.1.4.1.21067.2.1.3.4.1.0"; 
my $cyberoam_asExpiryDate	  = "1.3.6.1.4.1.21067.2.1.3.4.2.0"; # Exemple => Hex-STRING: 07 E2 05 12 

#liIdp
my $cyberoam_idpVersion		  = "1.3.6.1.4.1.21067.2.1.1.7.0";
my $cyberoam_idpSubStatus	  = "1.3.6.1.4.1.21067.2.1.3.5.1.0";
my $cyberoam_idpExpiryDate	  = "1.3.6.1.4.1.21067.2.1.3.5.2.0";

#liWebcat
my $cyberoam_webcatVersion	  = "1.3.6.1.4.1.21067.2.1.1.4.0";
my $cyberoam_webcatSubStatus  = "1.3.6.1.4.1.21067.2.1.3.6.1.0";
my $cyberoam_webcatExpiryDate = "1.3.6.1.4.1.21067.2.1.3.6.2.0";


# StatusService : 1 untouched,2 stopped,3 initializing,4 running,5 exiting,6 dead,7 unregistered
# StatusHA : 1 standalone, 2 active-passive, 3 active-active
my @tab_cyberoam_service_run = 
("1.3.6.1.4.1.21067.2.1.2.10.1.0", #pop3Service
"1.3.6.1.4.1.21067.2.1.2.10.2.0", #imap4Service
"1.3.6.1.4.1.21067.2.1.2.10.3.0", #smtpService
"1.3.6.1.4.1.21067.2.1.2.10.4.0", #ftpService
"1.3.6.1.4.1.21067.2.1.2.10.5.0", #httpService
"1.3.6.1.4.1.21067.2.1.2.10.6.0", #avService
"1.3.6.1.4.1.21067.2.1.2.10.7.0", #asService
"1.3.6.1.4.1.21067.2.1.2.10.8.0", #dnsService
"1.3.6.1.4.1.21067.2.1.2.10.9.0", #haService
"1.3.6.1.4.1.21067.2.1.2.10.10.0", #idpService
"1.3.6.1.4.1.21067.2.1.2.10.11.0", #apacheService
"1.3.6.1.4.1.21067.2.1.2.10.12.0", #ntpService
"1.3.6.1.4.1.21067.2.1.2.10.13.0", #tomcatService
"1.3.6.1.4.1.21067.2.1.2.10.14.0", #sslvpnService
"1.3.6.1.4.1.21067.2.1.2.10.15.0", #DataBaseService
"1.3.6.1.4.1.21067.2.1.2.10.16.0", #networkService
"1.3.6.1.4.1.21067.2.1.2.10.17.0", #garnerService
"1.3.6.1.4.1.21067.2.1.2.10.18.0", #droutingService
"1.3.6.1.4.1.21067.2.1.2.10.19.0", #sshdService
"1.3.6.1.4.1.21067.2.1.2.10.20.0" #dgdService
);


sub print_help() {
	printf "check SNMP interface via SNMP.\n";
	print "\n";
	print_usage();
	print "\n";
	print " -H (--hostname) 	Hostname to query - (required)\n";
	print " -D (--domain)		UDP/IPV6 UDP/IPV4 TCP/IPV6 TCP/IPV4 \n";
	print " -C (--community)	SNMP read community (defaults to public)\n";
	print " -v (--snmp_version) 1 for SNMP v1\n";
	print "		     2 for SNMP v2c (default)\n";
	print " -w	warning value in % (default: 60)\n";
	print " -c	critical value in % (default: 65)\n";
	print " -V (--version)	Plugin version\n";
	print " -h (--help)	usage help\n";
	print "\n";
}

sub print_usage() {
	print "Usage: \n";
	print " $PROGNAME -H <HOSTNAME> [-C <community>] [-D <domain>] [-w warning] [-c critical] \n";
	print " $PROGNAME [-h | --help]\n";
	print " $PROGNAME [-V | --version]\n";
}

sub error() {
	print (" ERROR SNMP ENV\n");
	#si l'host ne répond pas on blocke le script
	if (!defined($result))
	{
		if($snmp_version == 2)
		{
			($snmp, $snmperror) = Net::SNMP->session(
					-hostname  => $hostname,
					-domain    => $domain,
					-version   => 'snmpv1',
					-port      => $port,
					-community => $community
				);

			$result = $snmp->get_request("$cyberoam_descr");
			if (!defined($result))
			{
				printf("UNKNOWN ERROR: Description table : %s.\n", $snmp->error);
				$snmp->close;
				exit $ERRORS{"UNKNOWN"};
			}
		}
		else
		{
			printf("UNKNOWN ERROR: Description table : %s.\n",
			$snmp->error);
			$snmp->close;
			exit $ERRORS{"UNKNOWN"};
		}
	}
}

sub readOID {
    my($snmp,$oid) = @_;
	my $result = $snmp->get_request("$oid");
	return $$result{"$oid"};
}

my @priorities=(
                $ERRORS{CRITICAL},
                $ERRORS{WARNING},
                $ERRORS{UNKNOWN},
                $ERRORS{OK});
sub priority_state{
        my($a,$b) = @_;
        if( $a == $b ) { return $a; } #pas besoin d'aller dans la boucles si ils sont identiques

        foreach my $v (@priorities){
                if ( $v == $a || $v == $b ) { return $v; }
        }
}

sub translateDate {
	my($dt,$bool) = @_;
	
	if($bool==1)
	{
		my @datenumber = ($dt =~ /0x(.{4})(.{2})(.{2})(.{2})(.{2})(.{2})/g);
		my $year = hex("$datenumber[0]");
		my $month = hex("$datenumber[1]");
		if($month<10) {$month="0$month";}
		my $day = hex("$datenumber[2]");
		if($day<10) {$day="0$day";}
		my $hour = hex("$datenumber[3]");
		if($hour<10) {$hour="0$hour";}
		my $min = hex("$datenumber[4]");
		if($min<10) {$min="0$min";}
		my $sec = hex("$datenumber[5]");
		if($sec<10) {$sec="0$sec";}
		$dt = "$day/$month/$year $hour:$min:$sec";
	}
	else
	{
		my @datenumber = ($dt =~ /0x(.{4})(.{2})(.{2})/g);
		my $year = hex("$datenumber[0]");
		my $month = hex("$datenumber[1]");
		if($month<10) {$month="0$month";}
		my $day = hex("$datenumber[2]");
		if($day<10) {$day="0$day";}
		$dt = "$day/$month/$year";
	}
	return $dt;
}

########## MAIN ##########

&Getopt::Long::config('bundling');
GetOptions(
	"V"   => \$opt_V,        "version"        => \$opt_V,
	"D=s" => \$domain,       "domain=s"       => \$domain,
	"h"   => \$opt_h,        "help"           => \$opt_h,
	"C=s" => \$community,    "community=s"    => \$community,
	"H=s" => \$hostname,     "hostname=s"     => \$hostname,
	"v=i" => \$snmp_version, "snmp_version=i" => \$snmp_version,
	"w=i" => \$warning,      "warning=i"      => \$warning,
	"c=i" => \$critical,     "critical=i"     => \$critical,
);
# -h & --help print help
if ($opt_h) { print_help(); exit $ERRORS{'OK'}; }
if(!$hostname) {print_help(); exit $ERRORS{'OK'}; }
if(!$community) {print_help(); exit $ERRORS{'OK'}; }
if(!$domain) {print_help(); exit $ERRORS{'OK'}; }

if ($snmp_version == 2)
{
	($snmp, $snmperror) = Net::SNMP->session(
			-hostname   => $hostname,
			-version    => 'snmpv2c',
			-domain     => $domain,
			-port       => $port,
			-community  => $community,
			-timeout    => 2
		);
}
else
{
	($snmp, $snmperror) = Net::SNMP->session(
			-hostname   => $hostname,
 			-version    => 'snmpv1',
			-domain     => $domain,
			-port       => $port,
			-community  => $community,
			-timeout    => 2
		);
}

my $return=$ERRORS{OK};
if(!defined($snmp))
{
	print " Error SNMP not defined !!! \n";
	exit $ERRORS{"UNKNOWN"};
}
else
{
	$result = $snmp->get_request($cyberoam_cyberoamVersion);
	if(defined($result))
	{
		my $cyberoamVersion = $$result{"$cyberoam_cyberoamVersion"};
		$result = $snmp->get_request($cyberoam_liveUsers);
		if(defined($result))
		{			
			my $liveUsers = $$result{"$cyberoam_liveUsers"};
			$result = $snmp->get_request($cyberoam_systemDate);
			if(defined($result))
			{			
				my $systemDate = $$result{"$cyberoam_systemDate"};
				$systemDate=translateDate($systemDate,1);				

				print "Cyberoam version : $cyberoamVersion : Number of active users $liveUsers \n";
				print "Date system : $systemDate \n";
			}				
		}		

		my @type;
		$type [0] = "Antivirus";
		$type [1] = "Antispam";
		my @version;
		$version [0] = $cyberoam_avVersion;
		$version [1] = $cyberoam_asVersion;
		my @subStatus;
		$subStatus [0] = $cyberoam_avSubStatus;
		$subStatus [1] = $cyberoam_asSubStatus;
		my @expiryDate;
		$expiryDate [0] = $cyberoam_avExpiryDate;
		$expiryDate [1] = $cyberoam_asExpiryDate;
		my @ser;
		$ser [0] = "1.3.6.1.4.1.21067.2.1.2.10.6.0";
		$ser [1] = "1.3.6.1.4.1.21067.2.1.2.10.7.0";

		# Anti-virus & Anti-spam

		my $cmpt = 0;
		foreach my $oid (@version) 
		{		

			$result = $snmp->get_request($oid);
			if(defined($result))
			{			
				my $aVersion = $$result{"$oid"};
				$result = $snmp->get_request($subStatus[$cmpt]);
				if(defined($result))
				{			
					my $aSubStatus = $$result{"$subStatus[$cmpt]"};
					$result = $snmp->get_request($expiryDate[$cmpt]);
					if(defined($result))
					{			
						my $aExpiryDate = $$result{"$expiryDate[$cmpt]"};
						$aExpiryDate=translateDate($aExpiryDate,0);
						$result = $snmp->get_request($ser[$cmpt]); 

						if(defined($result))
						{
							my $aService = $$result{"$ser[$cmpt]"};
							switch ($aService)
							{
								case 1 
								{
									$service="untouched";
									$return = priority_state($return,$ERRORS{UNKNOWN}) 
								}
								case 2 
								{
									$service="stopped";
									$return = priority_state($return,$ERRORS{CRITICAL}) 
								}
								case 3 
								{
									$service="initializing";
									$return = priority_state($return,$ERRORS{WARNING}) 
								}
								case 4 
								{
									$service="running";
								}
								case 5 
								{
									$service="exiting";
									$return = priority_state($return,$ERRORS{WARNING}) 
								}
								case 6 
								{
									$service="dead";
									$return = priority_state($return,$ERRORS{CRITICAL}) 
								}
								case 7 
								{
									$service="unregistered";
									#$return = priority_state($return,$ERRORS{UNKNOWN}) 
								}
								else
								{ 
									$service="unknown";
									$return = priority_state($return,$ERRORS{UNKNOWN}) 
								}

							}
							
							if($service eq "unregistered")
							{
								$state="OK";
								$status="unregistered";
							}
							else
							{							
								switch ($aSubStatus) 
								{
									case 1	
									{
										$state="OK";
										$status="trial";
									}
									case 2	
									{
										$state="WARNING";
										$status="unsubscribed";
										$return = priority_state($return,$ERRORS{WARNING}) 
									}
									case 3	
									{ 
										$state="OK";
										$status="subscribed";
										if($service eq "stopped")
										{
											$state="CRITICAL";											
										}
									}
									case 4
									{ 
										$state="CRITICAL";
										$status="expired";
										$return = priority_state($return,$ERRORS{CRITICAL})
									}
									else
									{ 
										$state="UNKNOWN";
										$status="unknown";
										$return = priority_state($return,$ERRORS{UNKNOWN})
									}
								}
							}
							print "$state : $type[$cmpt] is $status : date expired is $aExpiryDate : service is $service\n";
						}
						else
						{
							error();
						}				
	    			}
					else
					{
						error();
					}
				}
				else
				{
					error();
				}
			}
			else
			{
				error();
			}
			$cmpt++;
		}
	}
}
exit $return;
