#!/usr/bin/perl -w
######################### check_snmp_lenovo #################
my $Version='1.0';
# Date : August 01 2018
# Author : Victor Marin
# Help : esia-sa.com
#################################################################

use Switch;
use strict;
use Net::SNMP;
use Getopt::Long;
use List::MoreUtils qw(uniq);
my $PROGNAME='check_snmp_lenovo.pl';
my $TIMEOUT = 50;
my %ERRORS=('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'DEPENDENT'=>4);
my ($opt_h,$opt_V);
my $domain = "UDP/IPV4"; # domain UDP/IPV6;UDP/IPV4;TCP/IPV6;TCP/IPV4
my $community = "public";
my $snmp_version = 2;
my ($hostname);
my $warning='70';
my $port='161';
my $critical='80';
my $result;
my $result_index;
#my @tab_value_read;
my ($snmp, $snmperror);
my $output = "";
my $target = "ALL";
my $val;
my $min_index = 0;
my $max_index = 100;
my $state = "OK";
my $return=$ERRORS{OK};

my $lenovo_descr 			      = "1.3.6.1.2.1.1.1.0";

my $lenovo_tempIndex		      = "1.3.6.1.4.1.2.3.51.3.1.1.2.1.1";
my $lenovo_tempDescr    	      = "1.3.6.1.4.1.2.3.51.3.1.1.2.1.2";
my $lenovo_tempReading            = "1.3.6.1.4.1.2.3.51.3.1.1.2.1.3"; # The measured temperature °C
my $lenovo_tempNominalReading     = "1.3.6.1.4.1.2.3.51.3.1.1.2.1.4";
my $lenovo_tempHealthStatus       = "1.3.6.1.4.1.2.3.51.3.1.1.2.1.11"; # A description of the temperature component status

my $lenovo_voltIndex		      = "1.3.6.1.4.1.2.3.51.3.1.2.2.1.1";
my $lenovo_voltDescr 		      = "1.3.6.1.4.1.2.3.51.3.1.2.2.1.2";   # A description of the voltage measurement channel.
my $lenovo_voltReading 		      = "1.3.6.1.4.1.2.3.51.3.1.2.2.1.3";   # The measured voltage.
my $lenovo_voltNominalReading     = "1.3.6.1.4.1.2.3.51.3.1.2.2.1.4";   # The nominal voltage, if available.
my $lenovo_voltHealthStatus       = "1.3.6.1.4.1.2.3.51.3.1.2.2.1.11";  # A description of the voltage component status.

my $lenovo_fanIndex  		      = "1.3.6.1.4.1.2.3.51.3.1.3.2.1.1";
my $lenovo_fanDescr  		      = "1.3.6.1.4.1.2.3.51.3.1.3.2.1.2";
my $lenovo_fanSpeed  		      = "1.3.6.1.4.1.2.3.51.3.1.3.2.1.3";   # Fan speed expressed in percent(%) of maximum RPM
my $lenovo_fanStatus 		      = "1.3.6.1.4.1.2.3.51.3.1.3.2.1.10";

 #0= unknown, 1 = good, 2 = warning, 3 = bad." 


my $lenovo_powerIndex	          = "1.3.6.1.4.1.2.3.51.3.1.11.2.1.1";
my $lenovo_powerFruName	          = "1.3.6.1.4.1.2.3.51.3.1.11.2.1.2";  # power module FRU name.	 
my $lenovo_powerHealthStatus	  = "1.3.6.1.4.1.2.3.51.3.1.11.2.1.6";  # A description of the power module status.
#unknown(0),good(1),warning(2),notAvailable(3),critical(4)

my $lenovo_cpuIndex               = "1.3.6.1.4.1.2.3.51.3.1.5.20.1.1";  # System CPU level
my $lenovo_cpuDescription         = "1.3.6.1.4.1.2.3.51.3.1.5.20.1.2";  # System CPU Description		 	 
my $lenovo_cpuCores	              = "1.3.6.1.4.1.2.3.51.3.1.5.20.1.7";  # System CPU number of cores
my $lenovo_cpuThreads             = "1.3.6.1.4.1.2.3.51.3.1.5.20.1.8";  # System CPU number of threads
my $lenovo_cpuHealthStatus        = "1.3.6.1.4.1.2.3.51.3.1.5.20.1.11"; # System CPU health status

my $lenovo_systemhealth           = "1.3.6.1.4.1.2.3.51.3.1.4.1";       # nonRecoverable(0), critical(2), nonCritical(4), normal(255)
		

my $lenovo_memoryIndex	          = "1.3.6.1.4.1.2.3.51.3.1.5.21.1.1";  # System Memory level VPD index
my $lenovo_memoryDescription      = "1.3.6.1.4.1.2.3.51.3.1.5.21.1.2";  # System memory Description (e.g. DIMM 1)	 
my $lenovo_memoryType	          = "1.3.6.1.4.1.2.3.51.3.1.5.21.1.6";  # System memory Type (e.g. DDR III SDRAM) 
my $lenovo_memorySize	          = "1.3.6.1.4.1.2.3.51.3.1.5.21.1.7";  # System memory size in GigaBytes
my $lenovo_memoryHealthStatus 	  = "1.3.6.1.4.1.2.3.51.3.1.5.21.1.8";  # A description of the memory component status.


my $lenovo_PowerConsumptionCpu    = "1.3.6.1.4.1.2.3.51.3.1.10.1.12";   # This field displays the power consumption of the processors.
my $lenovo_PowerConsumptionMemory = "1.3.6.1.4.1.2.3.51.3.1.10.1.13";   # This field displays the power consumption of the memory.


my $lenovo_diskIndex	          = "1.3.6.1.4.1.2.3.51.3.1.12.2.1.1";  # This column is used to identify a particular disk module inventory channel.
my $lenovo_diskFruName	          = "1.3.6.1.4.1.2.3.51.3.1.12.2.1.2";  # disk module FRU name	 
my $lenovo_diskHealthStatus	      = "1.3.6.1.4.1.2.3.51.3.1.12.2.1.3";  # A description of the disk module status

my $lenovo_raidVolumeName = "1.3.6.1.4.1.2.3.51.3.1.13.1.7.1.2";
my $lenovo_raidVolumeControllerName = "1.3.6.1.4.1.2.3.51.3.1.13.1.7.1.3";
my $lenovo_raidVolumeStatus = "1.3.6.1.4.1.2.3.51.3.1.13.1.7.1.4";
my $lenovo_raidVolumeSize = "1.3.6.1.4.1.2.3.51.3.1.13.1.7.1.5";


my $lenovo_raiddriveName ="1.3.6.1.4.1.2.3.51.3.1.13.1.3.1.2";
my $lenovo_raiddriveState ="1.3.6.1.4.1.2.3.51.3.1.13.1.3.1.4";
my $lenovo_raiddriveHealthStatus ="1.3.6.1.4.1.2.3.51.3.1.13.1.3.1.11";
my $lenovo_raiddriveSlot ="1.3.6.1.4.1.2.3.51.3.1.13.1.3.1.5";
my $lenovo_raiddriveSN ="1.3.6.1.4.1.2.3.51.3.1.13.1.3.1.17";

sub print_help() {
	printf "check SNMP interface via SNMP.\n";
	print "\n";
	print_usage();
	print "\n";
	print " -H (--hostname)		Hostname to query - (required)\n";
	print " -D (--domain)		UDP/IPV6 UDP/IPV4 TCP/IPV6 TCP/IPV4 \n";
	print " -C (--community)	SNMP read community (defaults to public)\n";
	print " -v (--snmp_version) 1 for SNMP v1\n";
	print "		     2 for SNMP v2c (default)\n";
	print " -T	target value (default: ALL)\n";
	print " -w	warning value (default: 70)\n";
	print " -c	critical value (default: 80)\n";
	print " -V (--version)	Plugin version\n";
	print " -h (--help)	usage help\n";
	print "\n";
}

sub error() {
	print (" ERROR SNMP \n Verify your OID");
	#si l'host ne répond pas on blocke le script
	if (!defined($result))
	{
		if($snmp_version == 2)
		{
			($snmp, $snmperror) = Net::SNMP->session(
					-hostname  => $hostname,
					-domain    => $domain,
					-version   => 'snmpv1',
					-port      => $port,
					-community => $community
				);

			$result = $snmp->get_request("$lenovo_descr");
			if (!defined($result))
			{
				printf("UNKNOWN ERROR: Description table : %s.\n", $snmp->error);
				$snmp->close;
				exit $ERRORS{"UNKNOWN"};
			}
		}
		else
		{
			printf("UNKNOWN ERROR: Description table : %s.\n",
			$snmp->error);
			$snmp->close;
			exit $ERRORS{"UNKNOWN"};
		}
	}	
}

my @priorities=(
                $ERRORS{CRITICAL},
                $ERRORS{WARNING},
                $ERRORS{UNKNOWN},
                $ERRORS{OK});
sub priority_state{
        my($a,$b) = @_;
        if( $a == $b ) { return $a; } #pas besoin d'aller dans la boucles si ils sont identiques

        foreach my $v (@priorities){
                if ( $v == $a || $v == $b ) { return $v; }
        }
}

sub print_usage() {
	 
	print "This snmpv2c plugin checks the hardware states on one HP server with the HP Insight System Management Agent \n";
	print "Usage : $0 <hostname or ip> <snmp community> <check> [device]";
	print "Usage : $0 <hostname or ip> <snmp community> <check> [device] [timeout en sec]";
	print "Usage : $0 <hostname or ip> <snmp community> <check> [min device] [max device] <timeout en sec> \n";
	print "The result also print <check name> <device> [details] : <state> => <description of this state> \n";
	print_commands();
	exit $ERRORS{"UNKNOWN"};
}

sub print_commands()
{
	print "Accepted commands :";
	print '"systemhealth"	: Realize all below tests';
	print '"volt"      		: The overall condition of the fault tolerant power supply sub-system.';
	print '"temp" 		    : The Temperature sensor condition.';
	print '"fan"       		: The condition of the fan.';
}

sub readOID {
    my($snmp,$oid) = @_;
	my $result = $snmp->get_request("$oid");
	return $$result{"$oid"};
}

sub check_volt_lenovo {
	my ($snmp) = @_;		
    my $result = $snmp->get_table(Baseoid =>"$lenovo_voltIndex");	     
     
     foreach my $key ( keys %$result)
     {
     	my $id = $$result{$key};
	    if(defined($id))
	    {
         	my $voltDescr = readOID($snmp,"$lenovo_voltDescr.$id");
		    my $voltReading = readOID($snmp,"$lenovo_voltReading.$id");
		    my $voltHealthStatus = readOID($snmp,"$lenovo_voltHealthStatus.$id");		    
		    
		    if($voltHealthStatus eq "Normal")
			{
				print "OK: VOLT $id ($voltDescr) : The volt is $voltReading V  state is $voltHealthStatus\n";				
			}
			else
			{
				print "WARNING: VOLT $id ($voltDescr) : The volt is $voltReading V  state is $voltHealthStatus\n";
				$return = priority_state($return,$ERRORS{WARNING})
			}		    
	    }        
	}	
}

sub check_temp_lenovo {
	my ($snmp,$warning,$critical) = @_;		
    my $result = $snmp->get_table(Baseoid =>"$lenovo_tempIndex");	     
     
    foreach my $key ( keys %$result)
    {
       my $id = $$result{$key};
	   if(defined($id))
	   {
        	my $tempDescr = readOID($snmp,"$lenovo_tempDescr.$id");
	    	my $tempReading = readOID($snmp,"$lenovo_tempReading.$id");
	    	my $tempHealthStatus = readOID($snmp,"$lenovo_tempHealthStatus.$id");
	    		    	
	    	if($tempReading < $warning)
			{
				if($tempHealthStatus eq "Normal" || $tempReading==0)
				{
					print "OK: TEMP $id ($tempDescr) : The temperature is $tempReading °C state is $tempHealthStatus \n";
				}
				else
				{
					print "WARNING: TEMP $id ($tempDescr) : The temperature is $tempReading °C state is $tempHealthStatus \n";
					$return = priority_state($return,$ERRORS{WARNING})
				}					
			}
			else
			{
				if($tempReading > $critical)
				{
					print "CRITICAL: TEMP $id ($tempDescr) : The temperature is $tempReading °C state is $tempHealthStatus \n";
					$return = priority_state($return,$ERRORS{CRITICAL})
				}
				else
				{
					print "WARNING: TEMP $id ($tempDescr) : The temperature is $tempReading °C state is $tempHealthStatus \n";
					$return = priority_state($return,$ERRORS{WARNING})
				}
			}
		}        
	}
}

sub check_cpu_lenovo{
	my ($snmp) = @_;
	my $result = $snmp->get_table(Baseoid =>"$lenovo_cpuIndex");
	
	foreach my $key ( keys %$result)
    {
       my $id = $$result{$key};
	   if(defined($id))
	   {
        	my $cpuDescr = readOID($snmp,"$lenovo_cpuDescription.$id");	    	    
	    	my $cpuCore = readOID($snmp,"$lenovo_cpuCores.$id");	
	    	my $cpuThread = readOID($snmp,"$lenovo_cpuThreads.$id");	
	    	my $cpuHealth = readOID($snmp,"$lenovo_cpuHealthStatus.$id");	
	    	
	    	if($cpuHealth eq "Normal")			    
	    	{
	    		print "OK: $cpuDescr : The CPU is $cpuHealth ($cpuCore Cores ; $cpuThread Threads) \n";
	    	}
	    	else
	    	{
	    		print "WARNING: $cpuDescr : The CPU is $cpuHealth ($cpuCore Cores ; $cpuThread Threads) \n";
	    		$return = priority_state($return,$ERRORS{WARNING})
	    	}
		}        
	}	
#my $lenovo_PowerConsumptionCpu    = "1.3.6.1.4.1.2.3.51.3.1.10.1.12";   # This field displays the power consumption of the processors.
}

sub check_mem_lenovo{
	my ($snmp) = @_;
	my $result = $snmp->get_table(Baseoid =>"$lenovo_memoryIndex");
		
	foreach my $key ( keys %$result)
    {
       my $id = $$result{$key};
	   if(defined($id))
	   {
        	my $memDescr = readOID($snmp,"$lenovo_memoryDescription.$id");
	    	my $memType = readOID($snmp,"$lenovo_memoryType.$id");	    	
	    	my $memSize = readOID($snmp,"$lenovo_memorySize.$id");		    	
	    	my $memHealth = readOID($snmp,"$lenovo_memoryHealthStatus.$id");	
	    			    	    	    		   
	    	if($memHealth eq "Normal")			    
	    	{
	    		print "OK: RAM ($memDescr) is $memHealth (Type : $memType ; Size : $memSize GB) \n";
	    	}
	    	else
	    	{
	    		print "WARNING: RAM ($memDescr) is $memHealth (Type : $memType ; Size : $memSize GB) \n";
	    		$return = priority_state($return,$ERRORS{WARNING})
	    	}
		}        
	}	
#my $lenovo_PowerConsumptionMemory = "1.3.6.1.4.1.2.3.51.3.1.10.1.13";   # This field displays the power consumption of the memory.
}

sub check_alim_lenovo{
	my ($snmp) = @_;
	
	my $result = $snmp->get_table(Baseoid =>"$lenovo_powerIndex");
		
	foreach my $key ( keys %$result)
    {
       my $id = $$result{$key};
	   if(defined($id))
	   {
        	my $powerFruName = readOID($snmp,"$lenovo_powerFruName.$id");
	    	my $powerHealth = readOID($snmp,"$lenovo_powerHealthStatus.$id");	    		    	
	    			    	  	    	
	    	if($powerHealth eq "Normal")			    
	    	{
	    		print "OK: $powerFruName is $powerHealth \n";
	    	}
	    	else
	    	{
	    		print "WARNING: $powerFruName is $powerHealth \n";
	    		$return = priority_state($return,$ERRORS{WARNING})
	    	}
	   }        
	}
}

sub check_fan_lenovo {
	my ($snmp) = @_;		
    my $result = $snmp->get_table(Baseoid =>"$lenovo_fanIndex");	     
     
     foreach my $key ( keys %$result)
     {
     	my $id = $$result{$key};
	    if(defined($id))
	    {
         	my $fanDescr = readOID($snmp,"$lenovo_fanDescr.$id");
		    my $fanSpeed = readOID($snmp,"$lenovo_fanSpeed.$id");
		    my $fanStatus = readOID($snmp,"$lenovo_fanStatus.$id");
		    
		    if($fanSpeed eq "offline")
		    {
		    	print "OK: FAN $id ($fanDescr) : The state is $fanStatus and Speed is $fanSpeed \n";
		    }
		    else
		    {
		    	if($fanStatus eq "Normal")
		    	{
		    		print "OK: FAN $id ($fanDescr) : The state is $fanStatus and Speed is $fanSpeed \n";
		    	}
		    	else
		    	{
		    		print "WARNING: FAN $id ($fanDescr) : The state is $fanStatus and Speed is $fanSpeed \n";
		    		$return = priority_state($return,$ERRORS{WARNING})
		    	}
		    }		    		   
	    }        
	}
}

sub check_raid_lenovo {
	my ($snmp) = @_;		
    my $result = $snmp->get_table(Baseoid =>"$lenovo_raidVolumeName");	     
     
     foreach my $key ( keys %$result)
     {
		if($key =~ /\.([0-9]*)$/)
		{
     		my $id = $1;
			my $Volumename = $$result{$key};
         	my $Controlleur = readOID($snmp,"$lenovo_raidVolumeControllerName.$id");
		    my $status = readOID($snmp,"$lenovo_raidVolumeStatus.$id");
		    my $size = readOID($snmp,"$lenovo_raidVolumeSize.$id");
		    if($status eq "Optimal")
		    {
		    	print "OK: Volume $Volumename ($size) on controller Controlleur is $status\n";
		    }
		    else
		    {
		    	print "CRITICAL: Volume $Volumename ($size) on controller Controlleur is $status\n";
		    	$return = priority_state($return,$ERRORS{CRITICAL})
		    }		    		   
	    }        
	}
}
sub check_disk_lenovo {
	my ($snmp) = @_;		
    my $result = $snmp->get_table(Baseoid =>"$lenovo_raiddriveName");	     
     
     foreach my $key ( keys %$result)
     {
		if($key =~ /\.([0-9]*)$/)
		{
     		my $id = $1;
			my $name = $$result{$key};
		    my $status = readOID($snmp,"$lenovo_raiddriveState.$id");
			my $healtStatus = readOID($snmp,"$lenovo_raiddriveHealthStatus.$id");
		    my $slot = readOID($snmp,"$lenovo_raiddriveSlot.$id");
			my $sn = readOID($snmp,"$lenovo_raiddriveSN.$id");
		    if($status eq "Online" && $healtStatus eq 'Normal')
		    {
		    	print "OK: drive $name ($sn) in slot $slot is $status and health status is $healtStatus\n";
		    }
            elsif($status =~/Hot\sSpare/ && $healtStatus eq 'Normal')
            {
		    	print "OK: drive $name ($sn) in slot $slot is $status and health status is $healtStatus\n";
            }
		    else
		    {
		    	print "CRITICAL: drive $name ($sn) in slot $slot is $status and health status is $healtStatus\n";
		    	$return = priority_state($return,$ERRORS{CRITICAL})
		    }		    		   
	    }        
	}
}
########## MAIN ##########

&Getopt::Long::config('bundling');
GetOptions(
	"V"   => \$opt_V,        "version"        => \$opt_V,
	"D=s" => \$domain,       "domain=s"       => \$domain,
	"h"   => \$opt_h,        "help"           => \$opt_h,
	"C=s" => \$community,    "community=s"    => \$community,
	"H=s" => \$hostname,     "hostname=s"     => \$hostname,
	"v=i" => \$snmp_version, "snmp_version=i" => \$snmp_version,
	"w=i" => \$warning,      "warning=i"      => \$warning,
	"c=i" => \$critical,     "critical=i"     => \$critical,
	"T=s" => \$target,		 "target=s"		  => \$target,
	"t=s" => \$TIMEOUT,		 "timeout=s"	  => \$TIMEOUT,
);

# -h & --help print help
if($opt_h) { print_help(); exit $ERRORS{'OK'}; }
if(!$hostname) {print_help(); exit $ERRORS{'OK'}; }
if(!$community) {print_help(); exit $ERRORS{'OK'}; }
if(!$domain) {print_help(); exit $ERRORS{'OK'}; }

if ($snmp_version == 2)
{
	($snmp, $snmperror) = Net::SNMP->session(
			-hostname   => $hostname,
			-version    => 'snmpv2c',
			-domain     => $domain,
			-port       => $port,
			-community  => $community,
			-timeout    => 2
		);
}
else
{
	($snmp, $snmperror) = Net::SNMP->session(
			-hostname  => $hostname,
			-version   => 'snmpv1',
			-domain    => $domain,
			-port      => $port,
			-community => $community,
			-timeout   => 2
		);
}

if(!defined($snmp))
{
	print " Error SNMP not defined !!! \n";
	exit $ERRORS{"UNKNOWN"};
}
else
{		
	$result = $snmp->get_request("$lenovo_descr");
	if (!defined($result))
	{
		printf("UNKNOWN ERROR: Description table : %s.\n", $snmp->error);
		$snmp->close;
		exit $ERRORS{"UNKNOWN"};
	}
	my $model = $$result{$lenovo_descr};
	print "Model: $model \n";	

	$target=`echo $target|tr '[:lower:]' '[:upper:]'`;
	
	if($target eq "VOLT\n")
    { 
    	check_volt_lenovo($snmp);
    }
    elsif($target eq "PWR\n")
    { 
    	check_alim_lenovo($snmp);
    }
    elsif($target eq "CPU\n")
    { 
    	check_cpu_lenovo($snmp);
    }
    elsif($target eq "TEMP\n")
    {  	
    	check_temp_lenovo($snmp,$warning,$critical);
    }
    elsif($target eq "FAN\n")
    {
    	check_fan_lenovo($snmp);
    } 
    elsif($target eq "RAM\n"  or $target eq "MEM\n")
    {
    	check_mem_lenovo($snmp);
    }    
    elsif($target eq "RAID\n")
    {
    	check_raid_lenovo($snmp);
    }
    elsif($target eq "DISK\n")
    {
    	check_disk_lenovo($snmp);
    }
    elsif($target eq "DISKHEALTH\n")
    {
		check_raid_lenovo($snmp);
		check_disk_lenovo($snmp);
	}	
    elsif($target eq "SYSTEMHEALTH\n")
    {
		
		my $product = readOID($snmp,"1.3.6.1.4.1.2.3.51.3.1.5.2.1.5.0");
		print "Product model: $product\n";
    	check_volt_lenovo($snmp);
    	check_cpu_lenovo($snmp);    	
    	check_mem_lenovo($snmp);
    	check_alim_lenovo($snmp);    	
    	check_fan_lenovo($snmp);    	    	   
    }
    else
    {
    	 print "Command $target doesn't exist \n";
    	 $return = priority_state($return,$ERRORS{UNKNWON}) 
    }
}
exit $return;
