-- # plugins
----Cisco
UPDATE esia_plugins SET plugin_path='/usr/local/esia/plugins/check_snmp_cisco_switch.pl'
WHERE plugin_name LIKE 'CHECK_SNMP_SW_CISCO%';

UPDATE esia_plugins SET plugin_default_parameter='-H $IP -C $SNMP_COM -T cpu -w 80 -c 90'
WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_LOAD';

UPDATE esia_plugins SET plugin_default_parameter='-H $IP -C $SNMP_COM -T mem -w 80 -c 90'
WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_MEM';

UPDATE esia_plugins SET plugin_default_parameter='-H $IP -C $SNMP_COM -T psu'
WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_ENV';

-- Correction APC
UPDATE esia_plugins
SET plugin_path='/usr/local/esia/plugins/check_snmp_apc_pdu.pl',plugin_default_parameter='-H $IP -C $SNMP_COM -T health -v 220'
WHERE plugin_name LIKE 'CHECK_SNMP_APC_PDU_HEALTH';

-- Corrections fortinet
UPDATE esia_plugins
SET plugin_default_parameter = replace(plugin_default_parameter,'%','')
WHERE plugin_name ilike '%fortinet%' AND plugin_default_parameter like '%\%%';

UPDATE esia_plugins
SET plugin_default_parameter = '-H $IP -C $SNMP_COM -T VPN -w 80 -c 90 --path=/tmp/'
WHERE plugin_name = 'CHECK_SNMP_FORTINET_VPN' AND plugin_default_parameter like '%$IP $SNMP_COM%';

-- Correction AXIS
UPDATE esia_plugins SET plugin_path = '/usr/local/esia/plugins/check_snmp_axis.pl'
WHERE plugin_name = 'CHECK_SNMP_AXIS_CAMERA_TEMP';


-- # rrd
-- cisco
UPDATE rrd_plugins SET rrd_regex = '#CPU\s+:\s+[0-9\.]*\s+[0-9\.]*\s+([0-9\.]*)#'
WHERE rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_LOAD') AND rrd_name = 'cpu';

UPDATE rrd_plugins SET rrd_regex='#cpu=([0-9]*)#'
WHERE rrd_name='cpu' AND rrd_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_LOAD');

UPDATE rrd_plugins SET rrd_regex='#Processor=([0-9\.]*)#'
WHERE rrd_name='cpu_mem' AND rrd_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_MEM');

UPDATE rrd_plugins SET rrd_regex='#I\/O=([0-9\.]*)#'
WHERE rrd_name='IO_mem' AND rrd_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_MEM');

--- APC_PDU
UPDATE rrd_plugins SET rrd_regex='#KWH=([0-9\.]*)#'
WHERE rrd_name='KWattH' AND rrd_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_APC_PDU_HEALTH');

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_APC_PDU_HEALTH'),'GAUGE','#va=([0-9\.]*)#','300','apparent_power','0','-1','va','LINE1','#007FFF',1);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_APC_PDU_HEALTH'),'GAUGE','#watts=([0-9\.]*)#','300','real_power','0','-1','watt','AREA','#83bc00',1);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_APC_PDU_HEALTH'),'GAUGE','#powerfactor=([0-9\.]*)#','300','power_factor','0','100','percent','AREA','#83bc00',2);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_APC_PDU_HEALTH'),'GAUGE','#amperes=([0-9\.]*)#','300','current','0','-1','amperes','AREA','#83bc00',3);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_APC_PDU_HEALTH'),'GAUGE','#voltage=([0-9\.]*)#','300','voltage','0','-1','volts','AREA','#83bc00',4);

---- UPS
INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_UPS_LINE'),'GAUGE','#([0-9\.]*)\s+Watt#','300','watt','0','-1','','LINE1','#0174DF',NULL);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_UPS_LINE'),'GAUGE','#([0-9\.]*)\s+Amperes#','300','current','0','-1','amperes','AREA','#83bc00',2);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_UPS_LINE'),'GAUGE','#([0-9\.]*)\s+Hz#','300','Frequency','0','-1','Hz','LINE1','#83bc00',3);

INSERT INTO rrd_plugins (rrd_plugin_id, rrd_type, rrd_regex, rrd_time,rrd_name,rrd_min, rrd_max, rrd_vertical_label, rrd_graph_type, rrd_graph_color,rrd_graph_num)
	VALUES ((select plugin_id from esia_plugins where plugin_name='CHECK_SNMP_UPS_LINE'),'GAUGE','#([0-9\.]*)%\s+load#','300','load','0','100','percent','AREA','#83bc00',4);

-- # included
-- Cisco
UPDATE esia_service_pattern_included
SET included_parameter='-H $IP -C $SNMP_COM -T cpu -w 80 -c 90'
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch') AND
	included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_LOAD');

UPDATE esia_service_pattern_included
SET included_parameter='-H $IP -C $SNMP_COM -T mem -w 80 -c 90'
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch') AND
	included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_MEM');

UPDATE esia_service_pattern_included
SET included_parameter='-H $IP -C $SNMP_COM -T psu',
	included_name='CHECK_SNMP_SW_CISCO_PSU',
	included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_PSU')
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch') AND
	included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_PSU');

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority)
SELECT 'CHECK_SNMP_SW_CISCO_FAN',
                (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'),
                (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FAN'),
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FAN'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_SW_CISCO_FAN' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch')
	);

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority)
SELECT 'CHECK_SNMP_SW_CISCO_TEMP',
                (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'),
                (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_TEMP'),
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_TEMP'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_SW_CISCO_TEMP' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch')
	);

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority)
SELECT 'CHECK_SNMP_SW_CISCO_FLASH',
                (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'),
                (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FLASH'),
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FLASH'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_SW_CISCO_FLASH' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch')
	);

-- APC
UPDATE esia_service_pattern_included
SET included_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_APC_PDU_HEALTH')
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_apc_pdu') AND
        included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_APC_PDU_HEALTH');


-- UPS
INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) SELECT 'CHECK_SNMP_UPS_STATE',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_STATE'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_STATE'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_UPS_STATE' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups')
	);

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) SELECT 'CHECK_SNMP_UPS_BATTERY',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_BATTERY'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_BATTERY'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_UPS_BATTERY' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups')
	);

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) SELECT 'CHECK_SNMP_UPS_ALARM',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_ALARM'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_ALARM'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_UPS_ALARM' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups')
	);

INSERT INTO esia_service_pattern_included (included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) SELECT 'CHECK_SNMP_UPS_INPUT',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_INPUT'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_INPUT'),300000,NULL,NULL,NULL,NULL,NULL,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_UPS_INPUT' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups')
	);

UPDATE esia_service_pattern_included SET included_name='CHECK_SNMP_UPS_LINE',
    included_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
WHERE included_pattern_id IN (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups')
	AND included_name='CHECK_SNMP_UPS';

-- ILO
INSERT INTO esia_service_pattern_included(
            included_name, included_pattern_id,
            included_plugin_id,
            included_parameter, included_interval,included_priority)
SELECT 'CHECK_ICMP',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ilo'),
	(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_ICMP'),
	(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_ICMP'),
	300000,1
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_ICMP' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ilo')
	);

-- iDrac
 INSERT INTO esia_service_pattern_included(
            included_name, included_pattern_id,
            included_plugin_id,
            included_parameter, included_interval,included_priority)
SELECT 'CHECK_SNMP_IDRAC_GLOBALHEALTH',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_dell_idrac'),
    (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_GLOBALHEALTH'),
    (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_GLOBALHEALTH'),
    300000,3
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_IDRAC_GLOBALHEALTH' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_dell_idrac')
	);

-- Extreme_networks
INSERT INTO esia_service_pattern_included(
            included_name, included_pattern_id,
            included_plugin_id,
            included_parameter, included_interval,included_priority)
SELECT 'CHECK_SNMP_EXTREME_NETWORKS_AP_LOAD',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_extreme_ap'),
	(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_EXTREME_NETWORKS_AP_LOAD'),
	(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_EXTREME_NETWORKS_AP_LOAD'),
	300000,2
WHERE NOT EXISTS (
	SELECT included_id
	FROM esia_service_pattern_included
	WHERE included_name='CHECK_SNMP_EXTREME_NETWORKS_AP_LOAD' AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_extreme_ap')
	);


-- Fortinet
UPDATE esia_service_pattern_included
SET included_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_FORTINET_VPN')
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_fortinet') AND
        included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_FORTINET_VPN');

UPDATE esia_service_pattern_included
SET included_parameter = replace(included_parameter,'%','')
WHERE included_pattern_id = (SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_fortinet') AND
        included_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name ILIKE '%FORTINET%') AND
        included_parameter like '%\%%';


-- # services
--cisco
UPDATE esia_services
SET service_parameter='-H $IP -C $SNMP_COM -T cpu -w 80 -c 90'
WHERE service_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_LOAD');

UPDATE esia_services
SET service_parameter='-H $IP -C $SNMP_COM -T mem -w 80 -c 90'
WHERE service_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_MEM');

UPDATE esia_services
SET service_parameter='-H $IP -C $SNMP_COM -T psu',
        service_plugin_id=(SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_PSU'),
        service_name='CHECK_SNMP_SW_CISCO_PSU'
WHERE service_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_PSU');

INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
	service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_TEMP'),service_device_id,300000,
		(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_TEMP'),4,
		'CHECK_SNMP_SW_CISCO_TEMP',4,
		(SELECT included_id
		 FROM esia_service_pattern_included
		 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_TEMP')
			AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
	(SELECT included_id
	 FROM esia_service_pattern_included
	 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_LOAD')
	 	AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'));

INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
	service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FAN'),service_device_id,300000,
		(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FAN'),4,
		'CHECK_SNMP_SW_CISCO_FAN',4,
		(SELECT included_id
		 FROM esia_service_pattern_included
		 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FAN')
			AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
	(SELECT included_id
	 FROM esia_service_pattern_included
	 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_LOAD')
	 	AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'));

INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
	service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FLASH'),service_device_id,300000,
		(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FLASH'),4,
		'CHECK_SNMP_SW_CISCO_FLASH',4,
		(SELECT included_id
		 FROM esia_service_pattern_included
		 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_FLASH')
			AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
	(SELECT included_id
	 FROM esia_service_pattern_included
	 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_LOAD')
	 	AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_switch'));

-- Idrac
INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
	service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_GLOBALHEALTH'),service_device_id,300000,
		(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_GLOBALHEALTH'),4,
		'CHECK_SNMP_IDRAC_GLOBALHEALTH',4,
		(SELECT included_id
		 FROM esia_service_pattern_included
		 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_GLOBALHEALTH')
			AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_dell_idrac'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
	(SELECT included_id
	 FROM esia_service_pattern_included
	 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_IDRAC_SYSHEALTH')
	 	AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_dell_idrac'));

-- ups
UPDATE esia_services
SET service_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
WHERE service_included_id = (SELECT included_id FROM esia_service_pattern_included WHERE included_name='CHECK_SNMP_UPS_LINE');

INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
        service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_STATE'),service_device_id,300000,
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_STATE'),4,
                'CHECK_SNMP_UPS_STATE',3,
                (SELECT included_id
                 FROM esia_service_pattern_included
                 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_STATE')
                        AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
        (SELECT included_id
         FROM esia_service_pattern_included
         WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
                AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'));


-------------------------------------------
INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
        service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_ALARM'),service_device_id,300000,
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_ALARM'),4,
                'CHECK_SNMP_UPS_ALARM',3,
                (SELECT included_id
                 FROM esia_service_pattern_included
                 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_ALARM')
                        AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
        (SELECT included_id
         FROM esia_service_pattern_included
         WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
                AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'));

-------------------------------------------
INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
        service_name,service_priority, service_included_id)

SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_BATTERY'),service_device_id,300000,
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_BATTERY'),4,
                'CHECK_SNMP_UPS_BATTERY',3,
                (SELECT included_id
                 FROM esia_service_pattern_included
                 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_BATTERY')
                        AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
        (SELECT included_id
         FROM esia_service_pattern_included
         WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
                AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'));


-------------------------------------------
INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
        service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_INPUT'),service_device_id,300000,
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_INPUT'),4,
                'CHECK_SNMP_UPS_INPUT',3,
                (SELECT included_id
                 FROM esia_service_pattern_included
                 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_INPUT')
                        AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
        (SELECT included_id
         FROM esia_service_pattern_included
         WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_UPS_LINE')
                AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ups'));

-------------------------------
UPDATE esia_services
SET service_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_SNMP_SW_CISCO_PSU'),
        service_plugin_id=(SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_PSU'),
        service_name='CHECK_SNMP_SW_CISCO_PSU'
WHERE service_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_CISCO_ENV');


UPDATE esia_services
SET service_parameter = replace(service_parameter,'%','')
WHERE service_plugin_id IN (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_FORTINET_VPN');



INSERT INTO public.esia_services(service_plugin_id, service_device_id, service_interval_time, service_parameter, service_previous_state,
        service_name,service_priority, service_included_id)
SELECT (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_ICMP'),service_device_id,300000,
                (SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_ICMP'),4,
                'CHECK_ICMP',3,
                (SELECT included_id
                 FROM esia_service_pattern_included
                 WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_ICMP')
                        AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ilo'))
FROM esia_plugins
JOIN esia_services ON esia_services.service_plugin_id = esia_plugins.plugin_id
WHERE service_included_id IN
        (SELECT included_id
         FROM esia_service_pattern_included
         WHERE included_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_ICMP')
                AND included_pattern_id=(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_ilo'));

-- # Delete
DELETE FROM esia_plugins WHERE plugin_name='CHECK_PAGE_RANK' AND plugin_id NOT IN(SELECT DISTINCT service_plugin_id FROM esia_services);
DELETE FROM esia_plugins WHERE plugin_name='CHECK_NRPE' AND plugin_id NOT IN(SELECT DISTINCT service_plugin_id FROM esia_services);
