--NAME:default_snmp_cisco_xr
--INFRA:CHECK
--PLUGINS:CHECK_SNMP_CISCOXR_LOAD,CHECK_SNMP_CISCOXR_MEM,CHECK_SNMP_CISCOXR_FRU,CHECK_SNMP_CISCOXR_SENSORS

INSERT INTO esia_service_patterns (pattern_id,pattern_name,pattern_description) VALUES (DEFAULT,'default_snmp_cisco_xr','Pattern SNMP Cisco pour les routeurs tournant sur IOS XR (testé sur des CISCOs ASR9006)');

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_SNMP_CISCOXR_LOAD',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_xr'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_CISCOXR_LOAD'),'-H $IP -T ciscoASR -C $SNMP_COM -w 70,70 -c 80,80',300000,NULL,NULL,NULL,NULL,NULL,7);

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_SNMP_CISCOXR_MEM',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_xr'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_CISCOXR_MEM'),'-H $IP -I -C $SNMP_COM -w 70,70 -c 80,80',300000,NULL,NULL,NULL,NULL,NULL,7);

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_SNMP_CISCOXR_FRU',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_xr'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_CISCOXR_FRU'),'-H $IP -C $SNMP_COM',300000,NULL,NULL,NULL,NULL,NULL,7);

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_SNMP_CISCOXR_SENSORS',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_snmp_cisco_xr'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_CISCOXR_SENSORS'),'-H $IP -C $SNMP_COM -w 60 -c 70',300000,NULL,NULL,NULL,NULL,NULL,7);

