--correction du path pour le seagate et l'ups
UPDATE esia_plugins
SET plugin_path = '/usr/local/esia/plugins/check_snmp_seagate_health.pl'
WHERE plugin_name = 'CHECK_SNMP_SEAGATE_HEALTH';

UPDATE esia_plugins
SET plugin_path = '/usr/local/esia/plugins/check_snmp_ups.pl'
WHERE plugin_path = '/usr/local/esia/plugins/check_ups.pl';

--correction des charactères BLANCK dans certains plugins de patterns avant la correction des valeurs nulles
UPDATE esia_service_pattern_included
SET included_name = trim(included_name)
WHERE included_name like 'CHECK_SNMP_LINUX_MEM%';

--issue #7 : Valeur null dans les patterns
UPDATE esia_service_pattern_included SET
included_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name=included_name)
WHERE included_parameter IS NULL;

--Bad parameters problems pour certaine  plugins de patterns
UPDATE esia_service_pattern_included SET
included_parameter=(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name=included_name)
WHERE included_name like 'CHECK%' AND (included_parameter like '%CHECKSN%' OR included_parameter like '%NRPE_HOST%');

--issue #10 : Plugins GESA manquants > Remplacement des anciens check_ilo
----Corrections des noms de l'ensemble des services iLO de type SYSTEMHEALTH, DISKHEALTH ou TEMP
UPDATE esia_services SET service_name=regexp_replace(service_name, 'CHECK_ILO.*_SNMP_', 'CHECK_SNMP_ILO_') WHERE service_plugin_id IN(SELECT plugin_id FROM esia_plugins WHERE plugin_name LIKE '%CHECK_ILO%');


----Liaison de l'ensemble des services iLO de type SYSTEMHEALTH, DISKHEALTH ou TEMP au nouveau pattern iLO
UPDATE esia_services SET service_included_id=(SELECT included_id FROM esia_service_pattern_included WHERE included_name='CHECK_SNMP_ILO_DISKHEALTH') WHERE service_included_id IN(SELECT included_id FROM esia_service_pattern_included WHERE included_name like 'CHECK_ILO%DISKHEALTH');
UPDATE esia_services SET service_included_id=(SELECT included_id FROM esia_service_pattern_included WHERE included_name='CHECK_SNMP_ILO_TEMP') WHERE service_included_id IN(SELECT included_id FROM esia_service_pattern_included WHERE included_name like 'CHECK_ILO%TEMP');
UPDATE esia_services SET service_included_id=(SELECT included_id FROM esia_service_pattern_included WHERE included_name='CHECK_SNMP_ILO_SYSTEMHEALTH') WHERE service_included_id IN(SELECT included_id FROM esia_service_pattern_included WHERE included_name like 'CHECK_ILO%SYSTEMHEALTH');

----Liaison de l'ensemble des services iLO de type SYSTEMHEALTH, DISKHEALTH ou TEMP aux nouveaux plugins iLO
UPDATE esia_services SET service_plugin_id=(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_ILO_DISKHEALTH') WHERE service_plugin_id IN(SELECT plugin_id FROM esia_plugins WHERE plugin_name like 'CHECK_ILO%DISKHEALTH');
UPDATE esia_services SET service_plugin_id=(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_ILO_TEMP') WHERE service_plugin_id IN(SELECT plugin_id FROM esia_plugins WHERE plugin_name like 'CHECK_ILO%TEMP');
UPDATE esia_services SET service_plugin_id=(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_SNMP_ILO_SYSTEMHEALTH') WHERE service_plugin_id IN(SELECT plugin_id FROM esia_plugins WHERE plugin_name like 'CHECK_ILO%SYSTEMHEALTH');

----Suppression des anciens plugins
DELETE FROM esia_plugins WHERE plugin_name LIKE 'CHECK_ILO%SNMP_SYSTEMHEALTH' OR plugin_name LIKE 'CHECK_ILO%SNMP_DISKHEALTH' OR plugin_name LIKE 'CHECK_ILO%SNMP_TEMP';

--Correction des paramètres des plugins zyxels
UPDATE esia_plugins
SET plugin_default_parameter = regexp_replace(plugin_default_parameter,'^H','-H')
WHERE plugin_default_parameter like 'H $IP -%';

UPDATE esia_service_pattern_included
SET included_parameter = regexp_replace(included_parameter,'^H','-H')
WHERE included_parameter like 'H $IP -%';

--Ajout des manufactuers et tags manquant dans les plugins
UPDATE esia_plugins
   SET plugin_manufacturer='CISCO'
 WHERE plugin_name LIKE '%CISCO%';

UPDATE esia_plugins
   SET plugin_manufacturer='HP'
 WHERE plugin_name LIKE '%HP%';
UPDATE esia_plugins
   SET plugin_manufacturer='Microsoft'
 WHERE plugin_name LIKE '%WIN%';
UPDATE esia_plugins
   SET plugin_manufacturer='Microsoft'
 WHERE plugin_name LIKE '%WMI%';
UPDATE esia_plugins
   SET plugin_manufacturer='Synology'
 WHERE plugin_name LIKE '%SYNOLOGY%';
UPDATE esia_plugins
   SET plugin_manufacturer='Qnap'
 WHERE plugin_name LIKE '%QNAP%';

UPDATE esia_plugins
   SET plugin_manufacturer='HP'
 WHERE plugin_name LIKE '%ILO%';

UPDATE esia_plugins
   SET plugin_manufacturer='Dell'
 WHERE plugin_name LIKE '%IDRAC%';

UPDATE esia_plugins
   SET plugin_manufacturer='Fortinet'
 WHERE plugin_name LIKE '%FORTINET%';

UPDATE esia_plugins
   SET plugin_tag='CPU,LOAD'
 WHERE plugin_name LIKE '%LOAD%';
UPDATE esia_plugins
   SET plugin_tag='MEMORY,RAM'
 WHERE plugin_name LIKE '%MEM%';
UPDATE esia_plugins
   SET plugin_tag='TEMPERATURE'
 WHERE plugin_name LIKE '%TEMP%';

UPDATE esia_plugins
   SET plugin_tag='HEALTH'
 WHERE plugin_name LIKE '%HEALTH%';

UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',DISK'
 WHERE plugin_name LIKE '%DISK%';

UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',ILO'
 WHERE plugin_name LIKE '%ILO%';

UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',IDRAC'
 WHERE plugin_name LIKE '%IDRAC%';

UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',SWITCH'
 WHERE plugin_name LIKE '%SW%';

UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',NAS'
 WHERE plugin_name LIKE '%SYNOLOGY%';
UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',NAS'
 WHERE plugin_name LIKE '%QNAP%';
UPDATE esia_plugins
   SET plugin_tag=plugin_tag||',NAS'
 WHERE plugin_name LIKE '%SEAGATE%';

UPDATE esia_plugins
   SET plugin_tag='PRINTER'
 WHERE plugin_name LIKE '%PRINTER%';

UPDATE esia_plugins
   SET plugin_manufacturer='HWG'
 WHERE plugin_name LIKE '%HWG%';

UPDATE esia_plugins
   SET plugin_tag='SENSORS'
 WHERE plugin_name LIKE '%HWG%';

UPDATE esia_plugins
   SET plugin_manufacturer='ENTERASYS'
 WHERE plugin_name LIKE '%ENTERASYS%';
UPDATE esia_plugins
   SET plugin_manufacturer='FORTINET'
 WHERE plugin_name LIKE '%FORTINET%';
UPDATE esia_plugins
   SET plugin_manufacturer='HP'
 WHERE plugin_name LIKE '%ILO%';

UPDATE esia_plugins
   SET plugin_manufacturer='ZYXEL'
 WHERE plugin_name LIKE '%ZYXEL%';
UPDATE esia_plugins
   SET plugin_manufacturer='WATCHGUARD'
 WHERE plugin_name LIKE '%WATCHGUARD%';

UPDATE esia_plugins
   SET plugin_manufacturer='STORMSHIELD'
 WHERE plugin_name LIKE '%STORMSHIELD%';

UPDATE esia_plugins
   SET plugin_manufacturer='RARITAN'
 WHERE plugin_name LIKE '%RARITAN%';


UPDATE esia_plugins
   SET plugin_manufacturer='FUJITSU'
 WHERE plugin_name LIKE '%FUJITSU%';

UPDATE esia_plugins
   SET plugin_manufacturer='JUNIPER'
 WHERE plugin_name LIKE '%JUNIPER%';
UPDATE esia_plugins
   SET plugin_manufacturer='NETGEAR'
 WHERE plugin_name LIKE '%NETGEAR%';

UPDATE esia_plugins
   SET plugin_manufacturer='CLAVISTER'
 WHERE plugin_name LIKE '%CLAVISTER%';
UPDATE esia_plugins
   SET plugin_manufacturer='CYBEROAM'
 WHERE plugin_name LIKE '%CYBEROAM%';

UPDATE esia_plugins
   SET plugin_manufacturer='ALLIEDTELESIS'
 WHERE plugin_name LIKE '%ALLIEDTELESIS%';
UPDATE esia_plugins
   SET plugin_manufacturer='EPDU'
 WHERE plugin_name LIKE '%EPDU%'; 

--Corrections des rrds (issue #8)
UPDATE rrd_plugins SET rrd_vertical_label = 'bps'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'out'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'bps'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'in'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'in_errors'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'out_errors'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'out_broadcast'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'in_unicast'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'out_unicast'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'packet/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'in_broadcast'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_SW_INTERFACE_EASY');

UPDATE rrd_plugins SET rrd_vertical_label = 'Lookups/s'
WHERE rrd_name = 'Lookup/s'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_WMI_DNS_STATS');

UPDATE rrd_plugins SET rrd_vertical_label = 'Updates/s'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name = 'DynamicUpdate'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_WMI_DNS_STATS');

UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name = 'ram'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_WINDOWS_MEM');

UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='ramswap' OR rrd_vertical_label='LINE1' OR rrd_vertical_label='AREA')
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_WINDOWS_MEM_SWAP');

UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='hdd' OR rrd_vertical_label='LINE1' OR rrd_vertical_label='AREA')
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_WINDOWS_STORAGE');


UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name = 'ram'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_PC_WINDOWS_MEM');

UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='ramswap' OR rrd_vertical_label='LINE1' OR rrd_vertical_label='AREA')
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_PC_WINDOWS_MEM_SWAP');

UPDATE rrd_plugins SET rrd_vertical_label = 'rpm'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'cpu_fan%'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_IPMI_SENSOR');

UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_PRINTER');


UPDATE rrd_plugins SET rrd_vertical_label = 'temperature'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_QNAP_HEALTH');


UPDATE rrd_plugins SET rrd_vertical_label = 'percent'
WHERE (rrd_vertical_label ='AREA' OR rrd_vertical_label='LINE1')
AND rrd_name like 'hdd'
AND rrd_plugin_id = (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CHECK_SNMP_QNAP_STORAGE');
